#
# $Id: accapi.pm,v 1.5 2008/07/31 14:09:00 rodney Exp $
#
# Copyright (C) Rodney Volz 1999, 2000
#
# Usage:
#
# my $api = new accapi($dbh);
#
#
# Methods:
#
# $api->bkill($id)    # Kill booking with the given buchungen.id
#
#
package acctools::accapi;
use strict;

sub new ($$$)
{
    my ($this,$dbh,$uid) = @_;
    my $class = ref ($this) || $this; # class or object
    my $self = {};

    bless ($self, $class);

#    $self->init ();

    return unless ($dbh &&
		   $uid);

    $self->{dbh} = $dbh;
    $self->{uid} = $uid;

    # leeres Objekt zurueckliefern
    return($self);
}


sub dbh
{
    my ($self) = @_;
    return($self->{dbh});
}


sub ping
{
    my ($self) = @_;

    my $ret;

    eval { $ret = $self->dbh->ping; };
    if ($@)
    {
	my $err = $@;
	$ret = 0;
	print STDERR "$err\n";
    }

    return($ret);
}





sub dump {
  die("dump: obsolete");

#    open(FP,">> bla") || die("cannot write");
#    print FP "written " . localtime(time()) . "\n";
#   close(FP);


    return("Still alive.\n");
} # sub dump



#
# Create a db connect and return a handle
#
sub getdbh {
  die("getdbh: obsolete");

    my ($self) = @_;

    return($self->dbh);

} # sub dump




#
# FIXME: test
#
sub getpid {
  die("getpid: obsolete");

#    open(FP,">> bla") || die("cannot write");
#    print FP "written " . localtime(time()) . "\n";
#   close(FP);


    return($$);

} # sub getpid



#
# Stornieren einer Buchung, ggfs. mit zugehoeriger Bankauszugs-Buchung.
#
# o FIXME: Sammelbuchungen (EZV) duerfen nicht storniert werden
# o FIXME: Bei Storno von EZV-Retoure muesste der Vorgang
#          acc_ezvretour korrekt mit abgehandelt werden (Brief,
#          Bearbeitungsgebuehr etc.)
#
sub bkill ($$)
{
#  die("obsolete");
    my ($self,$id) = @_;

    my $cmd;
    eval {
	die("bkill needs a UID value") unless ($self->{uid});

	# Better safe than sorry...
	$cmd = "LOCK TABLE buchungen,buchungen_storni,bumsatz,oponeu IN EXCLUSIVE MODE";
	$self->dbh->do($cmd);
	undef($cmd);

	my ($sum,$asum,$ksum);
	my ($bcount);


	my ($c1) = $self->dbh->selectrow_array("SELECT COUNT(*) FROM buchungen WHERE id = $id AND rgnr IS NULL");

	my ($c2) = $self->dbh->selectrow_array("SELECT COUNT(*) FROM oponeu WHERE id = $id");


	die("entry is contained in buchungen AND oponeu!?") if ($c1 && $c2);
	die("entry is contained neither in buchungen nor oponeu!?") if (!$c1 && !$c2);

	# BUMSATZ updaten, falls Bankbuchung
	$cmd = "SELECT id FROM bumsatz WHERE bnr = $id";
	my ($bumsid) = $self->dbh->selectrow_array($cmd);
	undef($cmd);

	if ($bumsid)
	{
	    $cmd = "UPDATE bumsatz SET bnr = NULL WHERE bnr = $id";
	    my $bumscnt = $self->dbh->do($cmd);
	    die("bumsatz update failed") unless ($bumscnt == 1);
	    undef($cmd);
	}


	# Aus BUCHUNGEN loeschen?
	if ($c1)
	{
	    # Pruefsummen merken
	    $cmd = "SELECT SUM(betrag), SUM(ABS(betrag)), SUM(konto) FROM buchungen WHERE id = $id AND rgnr IS NULL";
	    ($sum,$asum,$ksum) = $self->dbh->selectrow_array($cmd);
	    die("sum != 0") if ($sum != 0);
	    die("failed") unless (defined($asum));
#	die("rgnr must not be set") if ($rgnr > 0);
	    undef($cmd);


	    # Daten aus BUCHUNGEN nach BUCHUNGEN_STORNI uebertragen
	    $cmd = "INSERT INTO buchungen_storni (id,konto,betrag,
                                                  text,bdate,wdate,
                                                  beleg,owner,
                                                  sowner,sdate)
                    (SELECT id,konto,betrag,text,unix2odate(bdatum),
                            unix2odate(wdatum),beleg,owner,
                            $self->{uid} sowner,SYSDATE sdate
                       FROM buchungen WHERE id = $id)";

	    $bcount = $self->dbh->do($cmd);
	    die("insert failed") unless ($bcount > 0);
	    undef($cmd);

	    die("bcount != c1") unless ($bcount == $c1);

	    # Buchung in Relation BUCHUNGEN loeschen
	    $cmd = "DELETE FROM buchungen WHERE id = $id";
	    my $n = $self->dbh->do($cmd);
	    die("DELETE count $n does not match INSERT count $bcount") if ($n != $bcount);
	    undef($cmd);

	    # Check: Pruefsummen noch gleich?
	    my ($st_sum,$st_asum,$st_ksum) = $self->dbh->selectrow_array("SELECT SUM(betrag), SUM(ABS(betrag)), SUM(konto) FROM buchungen_storni WHERE id = $id");
	    die("failed") unless (defined($st_asum));
	    die("st_sum != 0") if ($st_sum != 0);
	    die("sum1 != sum2") unless ($st_asum == $asum);
	    die("ksum1 != ksum2") unless ($st_ksum == $ksum);

	} # endif c1 (Buchung war in Relation "buchungen" enthalten)
	elsif ($c2) # aus OPONEU loeschen?
	{
	    # "c2" enthaelt die Anzahl der Buchungen in OPONEU
	    $bcount = $c2;

	    # Pruefsummen merken
	    $cmd = "SELECT SUM(betrag), SUM(ABS(betrag)), SUM(konto) FROM oponeu WHERE id = $id";
	    ($sum,$asum,$ksum) = $self->dbh->selectrow_array($cmd);
	    die("sum(betrag): $sum != 0") if ($sum != 0);
	    die("failed") unless (defined($asum));
#	die("rgnr must not be set") if ($rgnr > 0);
	    undef($cmd);

	    # Buchung in Relation OPONEU loeschen
	    $cmd = "DELETE FROM oponeu WHERE id = $id";
	    my $n = $self->dbh->do($cmd);
	    die("DELETE count $n does not match INSERT count $bcount") if ($n != $bcount);
	    undef($cmd);

	} # endif c2 (oponeu)
	else
	{
	    die("this cannot happen");
	}







	# Log schreiben
	$cmd = "INSERT INTO actionlog (text,owner) VALUES ('bkill $id";
	$cmd .= " bumsid $bumsid" if ($bumsid);
	$cmd .= " (oponeu)" if ($c2);
	$cmd .= "',$self->{uid})";
	$self->dbh->do($cmd);
	undef($cmd);

	$self->dbh->do("commit");
	$self->dbh->commit;
    };
    if ($@)
    {
	my $err = $@;

	$err .= " cmd: " . $cmd;

	$self->dbh->do("ROLLBACK");
	$self->dbh->rollback;

	return($err);
    }

    return(0);
} # sub bkill





#
# Verschieben einer Buchung in die Relation BUCHUNGEN_BILANZ
#
# o FIXME: Sammelbuchungen (EZV) oder Bankbuchungen duerfen
#   nicht verschoeben werden, ebensowenig Rg.-Buchungen
#
sub btobilanz ($$)
{
#  die("obsolete");
    my ($self,$id) = @_;

    my $cmd;
    eval {
	die("btobilanz needs a UID value") unless ($self->{uid});

	# Better safe than sorry...
	$cmd = "LOCK TABLE buchungen,buchungen_bilanz,bumsatz,oponeu IN EXCLUSIVE MODE";
	$self->dbh->do($cmd);
	undef($cmd);

	my ($sum,$asum,$ksum);
	my ($bcount);


	my ($c1) = $self->dbh->selectrow_array("SELECT COUNT(*) FROM buchungen WHERE id = $id AND rgnr IS NULL");


	die("entry is not contained in buchungen") if (!$c1);

	# BUMSATZ updaten, falls Bankbuchung
	$cmd = "SELECT id FROM bumsatz WHERE bnr = $id";
	my ($bumsid) = $self->dbh->selectrow_array($cmd);
	undef($cmd);


	if ($bumsid)
	{
	    die("BUMSATZ bookings can not be moved to BUCHUNGEN_BILANZ");
	}


	# Aus BUCHUNGEN loeschen?
	if ($c1)
	{
	    # Pruefsummen merken
	    $cmd = "SELECT SUM(betrag), SUM(ABS(betrag)), SUM(konto) FROM buchungen WHERE id = $id AND rgnr IS NULL";
	    ($sum,$asum,$ksum) = $self->dbh->selectrow_array($cmd);
	    die("sum != 0") if ($sum != 0);
	    die("failed") unless (defined($asum));
#	die("rgnr must not be set") if ($rgnr > 0);
	    undef($cmd);


	    # Daten aus BUCHUNGEN nach BUCHUNGEN_BILANZ uebertragen
	    $cmd = "INSERT INTO buchungen_bilanz (id,konto,betrag,text,
                                                 bdate,wdate,beleg,owner,
                                                 sowner,sdate)
                    (SELECT id,konto,betrag,text,unix2odate(bdatum),
                            unix2odate(wdatum),beleg,owner,$self->{uid} sowner,
                            SYSDATE sdate FROM buchungen WHERE id = $id)";

	    $bcount = $self->dbh->do($cmd);
	    die("insert failed") unless ($bcount > 0);
	    undef($cmd);

	    die("bcount != c1") unless ($bcount == $c1);

	    # Buchung in Relation BUCHUNGEN loeschen
	    $cmd = "DELETE FROM buchungen WHERE id = $id";
	    my $n = $self->dbh->do($cmd);
	    die("DELETE count $n does not match INSERT count $bcount") if ($n != $bcount);
	    undef($cmd);

	    # Check: Pruefsummen noch gleich?
	    my ($st_sum,$st_asum,$st_ksum) = $self->dbh->selectrow_array("SELECT SUM(betrag), SUM(ABS(betrag)), SUM(konto) FROM buchungen_bilanz WHERE id = $id");
	    die("failed") unless (defined($st_asum));
	    die("st_sum != 0") if ($st_sum != 0);
	    die("sum1 != sum2") unless ($st_asum == $asum);
	    die("ksum1 != ksum2") unless ($st_ksum == $ksum);

	} # endif c1 (Buchung war in Relation "buchungen" enthalten)
	else
	{
	    die("this cannot happen");
	}



	# Log schreiben
	$cmd = "INSERT INTO actionlog (text,owner) VALUES ('btobilanz $id";
	$cmd .= " bumsid $bumsid" if ($bumsid);
	$cmd .= "',$self->{uid})";
	$self->dbh->do($cmd);
	undef($cmd);

	$self->dbh->do("commit");
	$self->dbh->commit;
    };
    if ($@)
    {
	my $err = $@;

	if ($cmd)
	{
	    $err .= " cmd: " . $cmd;
	}

	$self->dbh->do("ROLLBACK");
	$self->dbh->rollback;

	return($err);
    }

    return(0);
} # sub btobilanz


#
# Tag-related features
#
# Parameter: a string containing comma-separated Tags
# Returns: an array of tags, checked for existance
#
sub tag_list2arr
{
    my ($self,$s) = @_;

    my @list = split(/\s*,\s*/,$s);

    my $cmd = "SELECT id FROM konto_taglist WHERE name = ?";

    foreach my $t (@list)
    {
	my ($i) = $self->dbh->selectrow_array($cmd,undef,$t);
	die("no such tag '$t'") unless ($i);
    }

    return(@list);
}


# Parse accounting parameters.
# Input: a string, formatted as given below:
#
# Tag1: Value1\nTag2: Value2\n ...
#
# Comments are allowed, as lines starting with a '#'.
#
# Returns: hashref on success, otherwise zero.
#
#
sub accpar_parse
{
    my ($self,$s) = @_;

    my %h;

    my @lines = split(/[\n\r]+/,$s,0);

#    print "given: $s\n";
#    print "accpar_parse, line count: " . $#lines . "\n";

    foreach my $l (@lines)
    {
	next if ($l =~ /^\#/); # Allow and skip comments

	my ($t, $v) = ($l =~ /^(.*)\:\s+(.*)$/);
	return 0 unless ($t);

	$h{$t} = $v;
    }

    return(\%h);
}

# sub new_cust{
#         my ($self,$xfile,$USER, $schnipsel)=@_;
#         use XML::XPath;
#         my $xp          = XML::XPath->new(filename => $xfile);
#         my $cust_list   = $xp->find('/customerlist/customer');
#         my $dbh=$self->{dbh};
#         my @prj;
# 
#         my $konten="INSERT INTO $USER.konten ( id,name,korrent,klasse,saldo,bonitaet)
#                     VALUES (?,?,?,?,?,?)";
# 
#         my $auftrag="INSERT INTO $USER.auftrag (id,konto,text,bdate,owner,cdate)
#                         VALUES (?,?,?,sysdate,?,sysdate)";
# 
#         my $accverwaltung ="INSERT INTO $USER.konten_adm (id,konto,usr,pw,bdate)
#                            VALUES ($USER.konten_adm_seq.NEXTVAL,?,?,?,sysdate)";
#                            #VALUES (94265,?,?,?,sysdate)";
#                            #  TODO: grant all on konten_adm_seq to lfacc_ro;
# 
# 
#         my $address="INSERT INTO $USER.adressen (
#                         id,     name,           vorname,
#                         anrede, firma,          strasse,
#                         ort,    telefon,        fax,
#                         owner,  cdate,          konto
#                 )
#              VALUES (   ?,?,?,
#                         ?,?,?,
#                         ?,?,?,
#                         ?,sysdate,?
#                 )
#                 ";
# 
# 
#         $dbh->{PrintError}=0;
# 
#   my $sth_k               =$dbh->prepare($konten);
#         my $sth_a               =$dbh->prepare($auftrag);
#         my $sth_av              =$dbh->prepare($accverwaltung);
#         my $sth_adr             =$dbh->prepare($address);
#         my $gsf="OK";
#         my $user        = $ENV{USER};
# 
#         my $cmd         ="SELECT id from $USER.accusr where name='$user'";
#         my ($uid)       = $dbh->selectrow_array($cmd);
#         my $echo        ="/bin/echo";
#         my $cat         ="/bin/cat";
# 
#         foreach my $cust ($cust_list->get_nodelist) {
#                 # print "cust\n";
#                 my $name        =$cust->find('./konto/name');
# 		$name=~s/ /-/g;
# 		$name=~s/\//-/g;
# 		
#                 my $id          =$cust->find('./konto/id');
#                 my $klasse      =$cust->find('./konto/klasse');
#                 my $saldo       =$cust->find('./konto/saldo');
#                 my $bonitaet    =$cust->find('./konto/bonitaet');
# 
#                 my $vorname     =$cust->find('./adr/vorname');
#                 my $nachname    =$cust->find('./adr/name');
#                 my $anrede      =$cust->find('./adr/anrede');
#                 my $firma       =$cust->find('./adr/firma');
#                 my $strasse     =$cust->find('./adr/strasse');
#                 my $ort         =$cust->find('./adr/ort');
#                 my $fax         =$cust->find('./adr/fax');
#                 my $telefon     =$cust->find('./adr/telefon');
#                 my $email       =$cust->find('./adr/email');
# 
# 
#                 my ($pw) = (`/usr/bin/pwgen` =~ /^(\S+)\s+/);
# 
#                 # print "$id $name  $korrent $klasse  $saldo  $bonitaet \n";
#                 # hier noch mit RaiseError und PrintError optimieren
#                 eval{
#                          $sth_k->execute($id,$name,$id, $klasse, $saldo, $bonitaet);
#                          $sth_a->execute($id,$id,"Default",$uid);
#                          $sth_av->execute($id,$id,$pw);
#                          $sth_adr->execute($id,$nachname,$vorname,
#                                             $anrede, $firma, $strasse,
#                                             $ort, $telefon , $fax,
#                                             $uid, $id
#                                                );
#                 };
#                 if (my $err = $@){
#                         $gsf.=" $err";
#                         # $gsf.=" ";
#                 }
#                 $dbh->{PrintError}=1;
# 
#                 # prj
# 
# 
#                 my $dir ="/prj/gewerbe/active/".lc($name);
#                 if (-d $dir){
#                         $gsf.="\n bitte anderes Kundenkuerzel waehlen, $dir gibt es schon\n";
# 
#                 };
#                 push @prj,"\nmkdir $dir";
#                 foreach my $subd("CLOSED","SERV","VSERV","ROUTER", "domains","NETWORK","korrespondenz"){
#                         push @prj, "mkdir $dir/$subd";
#                 }
#                 push @prj, "$echo 'Organisation: $firma' >>$dir/bill-address";
#                 push @prj, "$echo 'Anrede: $anrede'     >>$dir/bill-address";
#                 push @prj, "$echo 'Name: $nachname'     >>$dir/bill-address";
#                 push @prj, "$echo 'Vorname: $vorname'   >>$dir/bill-address";
#                 push @prj, "$echo 'Strasse: $strasse'   >>$dir/bill-address";
#                 push @prj, "$echo 'Ort: $ort'           >>$dir/bill-address";
#                 push @prj, "$echo 'Telefon: $telefon'   >>$dir/bill-address";
#                 push @prj, "$echo 'FAX: $fax'           >>$dir/bill-address";
#                 push @prj, "$echo 'Zusatz:'             >>$dir/bill-address";
#                 push @prj, "$echo 'Abrechnung-Name: $name' >>$dir/bill-address";
#                 push @prj, "$echo 'Kundenummer: $id'    >>$dir/bill-address";
#                 push @prj, "$cat $dir/bill-address      >$dir/Log";
# 
#                 my $date=`/bin/date`;chomp $date;
#                 my $ersteintrag="\n$user, $date\n- Kunde angelegt\n$schnipsel\n";
#                 push @prj, "$echo '$ersteintrag'>>$dir/Log";
# 
#         }
#         return($gsf,\@prj);
# 
# 
# }
# 

1;
