#!/usr/bin/perl
#
# $Id: adr.pm,v 1.3 2003/01/27 15:29:02 rodney Exp $
#

package acctools::adr;
use strict;


#require "totex.pl" || die("cannot read totex.pl: $!");



sub new {
    my ($this) = shift;
    my $class = ref($this) || $this;
    my $self = {};
    bless $self, $class;

    return($self);
} # sub new()



#
# Postadresse aus einer Sammlung Tags zusammenbauen.
# Usage:
# 
# my $adrtool = new acctools::adr;
#
# my $rec = new dbrecs($dbh,"SELECT * FROM adressen WHERE id = 12345");
# $adrtool->mk($rec) || die("cannot compose adr");
#
#
sub mk
{
    my($self,$v) = @_;
    my($r);
    my(%var);
    my($n);

    my %v = %$v;


    foreach my $t (keys %v)
    {
	my $k = lc($t);
	substr($k,0,1) = uc(substr($k,0,1));

	next if ($k eq $t);

	$v{$k} = $v{$t};
    }
    
# Set linefeed and remark-characters
    my $NL = "\n";
    # We use tex.
    my $TEX_NL = "\\\\";
 
    
#    &tag_checknempty(%v,"Name");
#    &tag_checknempty(%v,"Strasse");
    
#($firma,$anrede,$name,$vorname,$zusatz,$strasse,$ort) = split(/\t/,$t);
    my $firma = "";
    $firma = $v{'Organization'};
    $firma = $v{'Organisation'} if ($firma eq "");
    $firma = $v{'Firma'} if ($firma eq "");
    my $zusatz = $v{'Zusatz'};


    my $anrede = $v{'Anrede'};
    my $name = $v{'Name'};
    my $vorname = $v{'Vorname'};
    my $strasse = $v{'Strasse'};
    my $ort = $v{'Ort'};

    if ($strasse eq "" && $zusatz eq "")
    {
	print STDERR "Missing 'Strasse' and 'Zusatz'.\n";
	return(2);
    }
    
    
    my $a_name = "";
    
### Adresse erzeugen
# 1. Fall: Firmenadresse mit Ansprechpartner generieren
    if ($a_name eq "" && $firma ne "" && $name ne "" && $anrede ne "")
    {
	$a_name = "$firma<NL>$anrede $vorname $name";
    }
    
# Anrede fehlt, aber Name und Vorname vorhanden
    if ($a_name eq "" && $firma ne "" && $vorname ne "" && $name ne "")
    {
	$a_name = "$firma<NL>$vorname $name";
    }
    
# 1. Fall: Firmenadresse mit Ansprechpartner generieren
    if ($a_name eq "" && $firma ne "" && $name eq "")
    {
	#$a_name = "Firma<NL>$firma";
	$a_name = "$firma";
    }

# 2. Fall: Privatperson
    if ($a_name eq "" && $name ne "" && $anrede ne "")
    {
	$a_name = "$anrede $vorname $name";
    }
    
# Anrede fehlt, aber Vor- u. Nachname sind vorhanden
    if ($a_name eq "" && $name ne "" && $vorname ne "")
    {
	$a_name = "$vorname $name";
    }

    if ($a_name eq "")
    {
	print STDERR "kd_mkadr: Could not compose name part of address.\n";
	print STDERR "The name part of the adress is missing essential information.\n";
	return;
    }
    
    if ($zusatz ne "")
    {
	$a_name = "$a_name<NL>$zusatz";
    }


    # Zu Anrede u. Namen jetzt Strasse/Ort hinzufuegen
    my $adresse = "$a_name<NL>";
    $adresse .= "$strasse<NL>" if ($strasse ne "");
    $adresse .= "$ort";
    $adresse =~ s/\s+/ /g;
    $adresse =~ s/^\s*//g;
    $adresse =~ s/\s*$//g;

    $anrede =~ s/^\s+//;
    $name =~ s/^\s+//;

    my $sehrgeehrter;
    if ($anrede ne "" && $name ne "")
    {
	if ($anrede =~ /^Herr/)
	{
	    $sehrgeehrter = "Sehr geehrter Herr";
	}
	
	if ($anrede =~ /^Frau/)
	{
	    $sehrgeehrter = "Sehr geehrte Frau";
	}
    }
    
#print "$adresse\n";
#if ($sehrgeehrter ne "")
#{
#    print "$sehrgeehrter $name\n";
#}

# Alle Daten aus dem Tagfile sollten auch in Sendletter zur
# Verfuegung stehen.
    my %var = %v;
    
    $var{"NAME"} = $name;
    $var{"VORNAME"} = $vorname;
    $var{"STRASSE"} = $strasse;
    $var{"ORT"} = $ort;
    $v->{"SEHRGEEHRTER"} = $sehrgeehrter;
    $v->{"ANREDE"} = $anrede;
#    $var{"TELEFON"} = $telefon;

# Disabled due to problems.
#    $a = $adresse;
#    $a =~ s/<NL>/$NL/g;
#    $var{"ADRESSE_ASC"} = $a;

    $v->{"ADRESSE"} = $adresse;
    $v->{"ADRESSE"} =~ s/<NL>/$TEX_NL/g;


    $v->{"ADRESSE_ASCII"} = $adresse;
    $v->{"ADRESSE_ASCII"} =~ s/<NL>/\n/g;
    
    
#    return(%var);
    return(1);
} # kd_mkadr()





#
# Zeichenkette escape'n, so dass Tex damit klarkommt
#
sub kd_texescape
{
    my($string) = @_;
    my($ret,$n,$n2,$l);


    if (!defined($string))
    {
	return(undef);
    }

    undef($ret);
    $l = length($string);


    $n = 0;
    $n2 = 0;

    my $c;
    while (($c = substr($string,$n,1)) ne "")
    {
	# Sonderzeichen, die escaped werden muessen
	if ($c =~ /[&%~]/)
	{
	    substr($ret,$n2++,1) = '\\';
	}

	substr($ret,$n2,1) = $c;
	++$n;
	++$n2;
    }


#    print "output is <$ret>\n";
    return($ret);
}



1;
