#
# $Id: rgpos.pm,v 1.11 2007/01/12 08:53:49 bb Exp $
#
# Klasse: rgpos, modelliert eine Rechnungszeile.
#

package acctools::rgpos;
use strict;

#
# Constructor
#
# Deprecated version:
#     my $rgp = new rgpos(text,betrag,ekonto,steuerschluessel)
#
sub new {
    my ($this,@arg) = @_;
    my $class = ref($this) || $this;
    my $self = {};
    bless $self, $class;
#    $self->initialize();

#    print "rgpos-new, self: $self, args " . join(",",@arg) . "\n"; # DEBUG

    if ($#arg == 3)
    {
	print STDERR "Warning: using deprecated calling interface of acctools::rgpos().\n";
	($self->{text},
	 $self->{betrag},
	 $self->{ekto},
	 $self->{steuerschluessel}) = @arg;
    }
    elsif ($#arg == 0)
    {
	my $c = $arg[0];

	usage() unless (ref($c) eq "HASH");

	$self->{text} = $c->{text} || die("missing text");
	$self->{text_date} = $c->{text_date};
	$self->{text_menge} = $c->{text_menge};
	$self->{text_epreis} = $c->{text_epreis};
	$self->{sort} = $c->{sort};

	$self->{betrag} = $c->{betrag};

	die("missing betrag") unless defined($self->{betrag});

	$self->{ekto} = $c->{ekto};
	if (!$self->{ekto})
	{
	    print STDERR "rgpos called from " . join(",",caller()) . "\n";
	    die("missing 'ekto'");
	}
	$self->{steuerschluessel} = $c->{steuerschluessel} || die("missing steuerschluessel");

    }
    else
    {
	usage();
    }

    if (!defined($self->{betrag}) || !defined($self->{text}))
    {
	print "Missing data, rgpos (" . join(",",@arg) . ")\n";

	print "caller: " . join(",",caller()) . "\n";
	die("failed");
    }

    # FIXME
    die("unsupported 'steuerschluessel'") if ($self->{steuerschluessel} != 13);

    return $self;
} # sub new()



sub usage
{
    die("Usage: my \$rgpos = new rgpos({ tag1 => value1, ... })");
    
#    die("exitus");
}

sub dump {
    my ($self) = @_;

    my $ret;

    $ret .= "  Text: $self->{text}\n";
    $ret .= sprintf("Betrag: %.4f\n",$self->{betrag});
    $ret .= sprintf("epreis: %s\n",$self->{text_epreis});
    $ret .= sprintf(" menge: %s\n",$self->{text_menge});
#    $ret .= sprintf(" ekto: %d/%d\n",$self->{ekt},$self->{steuerschluessel});

    return($ret);
}


1;


